/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * ItemMode defines if items should be droppable or deleted in a Region
 */
@Getter
@AllArgsConstructor
public enum ItemMode implements Flag.Value<ItemMode> {

    ACTIVE("FLAG_ITEMS_ACTIVE"),
    INACTIVE("FLAG_ITEMS_INACTIVE");

    private static ItemMode[] values;
    private final String chatValue;

    @Override
    public ItemMode[] getValues() {
        if (ItemMode.values == null) {
            ItemMode.values = ItemMode.values();
        }
        return ItemMode.values;
    }

    @Override
    public ItemMode getValue() {
        return this;
    }

    @Override
    public ItemMode getValueOf(final String name) {
        try {
            return ItemMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            if (name.equalsIgnoreCase("false")) {
                return ItemMode.INACTIVE;
            }
            return ItemMode.ACTIVE;
        }
    }
}
